<template>
    <!-- 静态  栋舍信息 areaInfo-->
    <div class="areaInfo">
        <h2 style="margin-bottom: 20px;padding-bottom:7px;border-bottom:2px solid #ddd">栋舍信息</h2>
        <header id="header">
            <el-row type="flex" :gutter="20">
                <el-col :span="4">
                    <el-input v-model="search" placeholder="请选择"></el-input>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="getBuildList">查找</el-button>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="add">新增</el-button>
                </el-col>
            </el-row>
        </header>
        <section>
            <article class="table">
                <el-table
                    :data="tableData"
                    tooltip-effect="dark"
                    style="width: 100%"
                >
                    <el-table-column prop="id" label="序号" width="80"></el-table-column>
                    <el-table-column prop="name" label="栋舍" width="180"></el-table-column>
                    <el-table-column prop="capacity" label="最大容量" width="180"></el-table-column>
                    <el-table-column prop="manager" label="负责人">
                        <template v-slot="scope">
                            <div v-for="item in $store.state['workerList']" :key="item.value">
                                <span v-if="item.id == scope.row['manager']">{{ item.name }}</span>
                            </div>
                        </template>
                    </el-table-column>
                    <el-table-column label="操作" width="150">
                        <template slot-scope="scope">
                            <el-button @click="edit(scope.row)" type="text" size="small">编辑</el-button>
                            <el-popconfirm title="是否删除此设备的信息？" @onConfirm="del(scope.row)">
                                <el-button slot="reference" type="text" size="small">删除</el-button>
                            </el-popconfirm>
                        </template>
                    </el-table-column>
                </el-table>

                <el-row type="flex" justify="end">
                    <el-col :span="8" class="pagination">
                        <el-pagination
                            @current-change="pageChange"
                            background
                            layout="prev, pager, next"
                            :page-count="Number(totalPages)"
                        ></el-pagination>
                    </el-col>
                </el-row>
            </article>
        </section>

        <el-dialog title="新增/编辑" :visible.sync="isShow" width="40%">
            <el-row type="flex">
                <el-col :span="20">
                    <el-form ref="addBuild" :model="formData" :rules="rules" label-width="140px">
                        <el-form-item label="栋舍名字">
                            <el-input v-model="formData.name"></el-input>
                        </el-form-item>

                        <el-form-item label="最大容量">
                            <el-input v-model="formData.capacity"></el-input>
                        </el-form-item>

                        <el-form-item label="负责人">
                            <el-select v-model="formData.manager" filterable placeholder="请选择">
                                <el-option
                                    v-for="item in $store.state['workerList']"
                                    :key="item.id"
                                    :label="`${item.name}(${item.position})`"
                                    :value="item.id"
                                ></el-option>
                            </el-select>
                        </el-form-item>

                        <el-form-item>
                            <el-button @click="isShow=false">取 消</el-button>
                            <el-button type="primary" @click="submitForm('addBuild')">保 存</el-button>
                        </el-form-item>
                    </el-form>
                </el-col>
            </el-row>
        </el-dialog>
    </div>
</template>

<script>
import {
    reqBuildList,
    reqAddOrUpdateBuild,
    reqDelBuild
} from "@/api/fileInfo.js";

const pageSize = 10;
const rules = {};

export default {
    name: "areaInfo",
    data() {
        return {
            search: "",
            pageNum: 1,
            tableData: [],
            totalPages: 0,
            isShow: false,
            formData: {
                name: "保育一舍",
                capacity: "156",
                manager: this.$store.state.workerList[0].id
            },
            rules
        };
    },
    created() {
        // 入库管理列表
        this.getBuildList();
    },
    methods: {
        submitForm(formName) {
            this.$refs[formName].validate(valid => {
                if (valid) {
                    reqAddOrUpdateBuild(this.formData)
                        .then(res => {
                            // 入库管理列表
                            this.getBuildList();
                            // this.$message.success("成功！");
                            if (res.errCode) {
                                this.$message.error(res.errMsg);
                            } else {
                                this.$message.success("成功");
                            }
                            // this.isShow = false;
                        })
                        .catch(err => {
                            console.log(err);
                            this.$message.error("失败！");
                        });
                 
                } else {
                    return false;
                }
            });
        },
        // 入库管理列表
        getBuildList() {
            reqBuildList({
                searchStr: this.search,
                pageSize,
                pageNum: this.pageNum
            })
                .then(res => {
                    this.tableData = res.content;
                    this.totalPages = res.totalPages;
                })
                .catch(err => {
                    console.log(err);
                });
        },
        add() {
            this.isShow = true;
            // 有id是update 没id是add
            delete this.formData.id;
        },
        edit(row) {
            this.formData = row;
            this.isShow = true;
        },
        del(row) {
            reqDelBuild(row.id)
                .then(res => {
                    console.log(res);
                    // 入库管理列表
                    this.getBuildList();
                    if (res.code == "success") {
                        this.$message.success(res.msg);
                    }
                    if (res.errCode == "delete failed") {
                        this.$message.error(res.errMsg);
                    }
                })
                .catch(err => {
                    console.log(err);
                });
        },
        pageChange(p) {
            console.log(p);
            this.pageNum = p;
            // 入库管理列表
            this.getBuildList();
        }
    }
};
</script>

<style lang="scss" scoped>
#header {
    margin-bottom: 15px;
}
.table {
    .pagination {
        margin-top: 20px;
    }
}
</style>